org.mariadb.jdbc

## Class MariaDbStatement

- java.lang.Object
- - org.mariadb.jdbc.MariaDbStatement

All Implemented Interfaces:
  AutoCloseable, Cloneable, Statement, Wrapper

Direct Known Subclasses:
  AbstractMariaDbPrepareStatement

    public class MariaDbStatement
    extends Object
    implements Statement, Cloneable

### Field Summary

Fields
`protected boolean` `binaryData`
`protected MariaDbConnection` `connection` the Connection object.
`static Pattern` `deleteEndSemicolonPattern`
`protected ExecutionResult` `executionResult`
`protected int` `fetchSize`
`protected String` `firstRewrite`
`protected boolean` `isRewriteable`
`protected Protocol` `protocol` the protocol used to talk to the server.
`protected int` `resultSetScrollType`
`protected TimerTask` `timerTask` The actual query result.

### Fields inherited from interface java.sql.Statement

`CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

### Constructor Summary

Constructors
Constructor and Description
`MariaDbStatement(MariaDbConnection connection, int resultSetScrollType)` Creates a new Statement.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`void` `addBatch(String sql)` Adds the given SQL command to the current list of commmands for this `Statement` object.
`protected void` `cacheMoreResults(ExecutionResult execResult, int fetchSize, boolean canHaveCallableResult)`
`void` `cancel()` Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement.
`protected void` `checkClose()` Check if statement is closed, and throw exception if so.
`void` `clearBatch()` Empties this `Statement` object's current list of SQL send.
`void` `clearWarnings()` Clears all the warnings reported on this `Statement` object.
`MariaDbStatement` `clone()` Clone statement.
`void` `close()` Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed.
`void` `closeOnCompletion()`
`protected boolean` `execute(Query query, int fetchSize)` executes a query.
`boolean` `execute(String queryString)` executes a query.
`boolean` `execute(String sql, int autoGeneratedKeys)` Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval.
`boolean` `execute(String sql, int[] columnIndexes)` Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`boolean` `execute(String sql, String[] columnNames)` Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`int[]` `executeBatch()` Execute statements. depending on option, queries mays be rewritten : those queries will be rewritten if possible to INSERT INTO ...
`protected ResultSet` `executeQuery(Query query)` executes a select query.
`ResultSet` `executeQuery(String queryString)` executes a select query.
`protected void` `executeQueryEpilog(QueryException queryException)` Reset timeout after query, re-throw SQL exception
`protected int` `executeUpdate(Query query)` Executes an update.
`int` `executeUpdate(String queryString)` Executes an update.
`int` `executeUpdate(String sql, int autoGeneratedKeys)` Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval.
`int` `executeUpdate(String sql, int[] columnIndexes)` Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`int` `executeUpdate(String sql, String[] columnNames)` Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`Connection` `getConnection()` Gets the connection that created this statement.
`int` `getFetchDirection()` Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object.
`int` `getFetchSize()` Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object.
`ResultSet` `getGeneratedKeys()` Retrieves any auto-generated keys created as a result of executing this `Statement` object.
`protected int` `getInsertIncipit(String sql)` Parses the input string to understand if it is an INSERT statement.
`int` `getMaxFieldSize()` Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object.
`int` `getMaxRows()` Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain.
`boolean` `getMoreResults()` Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`.
`boolean` `getMoreResults(int current)` Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object.
`Protocol` `getProtocol()` returns the protocol.
`int` `getQueryTimeout()` Retrieves the number of seconds the driver will wait for a `Statement` object to execute.
`ResultSet` `getResultSet()` Retrieves the current result as a ResultSet object.
`int` `getResultSetConcurrency()` Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.
`int` `getResultSetHoldability()` Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.
`int` `getResultSetType()` Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.
`int` `getUpdateCount()` Retrieves the current result as an update count; if the result is a ResultSet object or there are no more results, -1 is returned.
`SQLWarning` `getWarnings()` Retrieves the first warning reported by calls on this `Statement` object.
`boolean` `isClosed()` Retrieves whether this `Statement` object has been closed.
`boolean` `isCloseOnCompletion()`
`protected void` `isInsertRewriteable(String sql)` Parses the sql string to understand whether it is compatible with rewritten batches.
`boolean` `isPoolable()` Returns a value indicating whether the `Statement` is poolable or not.
`boolean` `isWrapperFor(Class<?> interfaceOrWrapper)` Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
`protected ResultSet` `retrieveCallableResult()` Retrieve the output parameter result
`void` `setCursorName(String name)` Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods.
`void` `setEscapeProcessing(boolean enable)` Sets escape processing on or off.
`void` `setFetchDirection(int direction)` Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object.
`void` `setFetchSize(int rows)` Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for `ResultSet` objects genrated by this `Statement`.
`void` `setLocalInfileInputStream(InputStream inputStream)` Sets the inputStream that will be used for the next execute that uses "LOAD DATA LOCAL INFILE".
`void` `setMaxFieldSize(int max)` Sets the limit for the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object.
`void` `setMaxRows(int max)` Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number.
`void` `setPoolable(boolean poolable)` Requests that a `Statement` be pooled or not pooled.
`void` `setQueryTimeout(int seconds)` Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds.
`protected void` `skipMoreResults()`
`protected Query` `stringToQuery(String queryString)`
`static void` `unloadDriver()` Provide a "cleanup" method that can be called after unloading driver, to fix Tomcat's obscure classpath handling.
`<T> T` `unwrap(Class<T> iface)` Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.sql.Statement

`executeLargeBatch, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, getLargeMaxRows, getLargeUpdateCount, setLargeMaxRows`

### Field Detail

#### protocol

    protected Protocol protocol

the protocol used to talk to the server.

#### connection

    protected MariaDbConnection connection

the Connection object.

#### binaryData

    protected boolean binaryData

#### timerTask

    protected TimerTask timerTask

The actual query result.

#### isRewriteable

    protected boolean isRewriteable

#### firstRewrite

    protected String firstRewrite

#### fetchSize

    protected int fetchSize

#### deleteEndSemicolonPattern

    public static final Pattern deleteEndSemicolonPattern

#### executionResult

    protected ExecutionResult executionResult

#### resultSetScrollType

    protected int resultSetScrollType

### Constructor Detail

#### MariaDbStatement

    public MariaDbStatement(MariaDbConnection connection,
                            int resultSetScrollType)

Creates a new Statement.

Parameters:
  `connection` - the connection to return in getConnection.
  `resultSetScrollType` - one of the following `ResultSet` constants: `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`

### Method Detail

#### clone

    public MariaDbStatement clone()
                           throws CloneNotSupportedException

Clone statement.

Overrides:
  `clone` in class `Object`
Returns:
  Clone statement.
Throws:
  `CloneNotSupportedException` - if any error occur.

#### unloadDriver

    public static void unloadDriver()

Provide a "cleanup" method that can be called after unloading driver, to fix Tomcat's obscure classpath handling.

#### getProtocol

    public Protocol getProtocol()

returns the protocol.

Returns:
  the protocol used.

#### cacheMoreResults

    protected void cacheMoreResults(ExecutionResult execResult,
                                    int fetchSize,
                                    boolean canHaveCallableResult)

#### executeQueryEpilog

    protected void executeQueryEpilog(QueryException queryException)
                               throws SQLException

Reset timeout after query, re-throw SQL exception

Parameters:
  `queryException` - exception if exist
Throws:
  `SQLException` - exception with new message in case of timer timeout.

#### execute

    protected boolean execute(Query query,
                              int fetchSize)
                       throws SQLException

executes a query.

Parameters:
  `query` - the query
  `fetchSize` - fetch size
Returns:
  true if there was a result set, false otherwise.
Throws:
  `SQLException` - the error description

#### execute

    public boolean execute(String queryString)
                    throws SQLException

executes a query.

Specified by:
  `execute` in interface `Statement`
Parameters:
  `queryString` - the query
Returns:
  true if there was a result set, false otherwise.
Throws:
  `SQLException` - if the query could not be sent to server

#### execute

    public boolean execute(String sql,
                           int autoGeneratedKeys)
                    throws SQLException

Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval. The driver will ignore this signal if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getInternalMoreResults` to move to any subsequent result(s).

Specified by:
  `execute` in interface `Statement`
Parameters:
  `sql` - any SQL statement
  `autoGeneratedKeys` - a constant indicating whether auto-generated keys should be made available for retrieval using the method `getGeneratedKeys`; one of the following constants: `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`
Returns:
  `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the second parameter supplied to this method is not `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`.
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method with a constant of Statement.RETURN_GENERATED_KEYS
See Also:
  `getResultSet()`, `getUpdateCount()`, `getMoreResults()`, `getGeneratedKeys()`

#### execute

    public boolean execute(String sql,
                           int[] columnIndexes)
                    throws SQLException

Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Under some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getInternalMoreResults` to move to any subsequent result(s).

Specified by:
  `execute` in interface `Statement`
Parameters:
  `sql` - any SQL statement
  `columnIndexes` - an array of the indexes of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
Returns:
  `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the elements in the `int` array passed to this method are not valid column indexes
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `getResultSet()`, `getUpdateCount()`, `getMoreResults()`

#### execute

    public boolean execute(String sql,
                           String[] columnNames)
                    throws SQLException

Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getInternalMoreResults` to move to any subsequent result(s).

Specified by:
  `execute` in interface `Statement`
Parameters:
  `sql` - any SQL statement
  `columnNames` - an array of the names of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
Returns:
  `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the elements of the `String` array passed to this method are not valid column names
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `getResultSet()`, `getUpdateCount()`, `getMoreResults()`, `getGeneratedKeys()`

#### executeQuery

    protected ResultSet executeQuery(Query query)
                              throws SQLException

executes a select query.

Parameters:
  `query` - the query to send to the server
Returns:
  a result set
Throws:
  `SQLException` - if something went wrong

#### executeQuery

    public ResultSet executeQuery(String queryString)
                           throws SQLException

executes a select query.

Specified by:
  `executeQuery` in interface `Statement`
Parameters:
  `queryString` - the query to send to the server
Returns:
  a result set
Throws:
  `SQLException` - if something went wrong

#### executeUpdate

    protected int executeUpdate(Query query)
                         throws SQLException

Executes an update.

Parameters:
  `query` - the update query.
Returns:
  update count
Throws:
  `SQLException` - if the query could not be sent to server.

#### executeUpdate

    public int executeUpdate(String queryString)
                      throws SQLException

Executes an update.

Specified by:
  `executeUpdate` in interface `Statement`
Parameters:
  `queryString` - the update query.
Returns:
  update count
Throws:
  `SQLException` - if the query could not be sent to server.

#### executeUpdate

    public int executeUpdate(String sql,
                             int autoGeneratedKeys)
                      throws SQLException

Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval. The driver will ignore the flag if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Specified by:
  `executeUpdate` in interface `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
  `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be made available for retrieval; one of the following constants: `Statement.RETURN_GENERATED_KEYS` `Statement.NO_GENERATED_KEYS`
Returns:
  either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the given SQL statement returns a `ResultSet` object, or the given constant is not one of those allowed
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method with a constant of Statement.RETURN_GENERATED_KEYS
Since:
  1.4

#### executeUpdate

    public int executeUpdate(String sql,
                             int[] columnIndexes)
                      throws SQLException

Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Specified by:
  `executeUpdate` in interface `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
  `columnIndexes` - an array of column indexes indicating the columns that should be returned from the inserted row
Returns:
  either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the SQL statement returns a `ResultSet` object, or the second argument supplied to this method is not an `int` array whose elements are valid column indexes
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### executeUpdate

    public int executeUpdate(String sql,
                             String[] columnNames)
                      throws SQLException

Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Specified by:
  `executeUpdate` in interface `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
  `columnNames` - an array of the names of the columns that should be returned from the inserted row
Returns:
  either the row count for `INSERT`, `UPDATE`, or `DELETE` statements, or 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the SQL statement returns a `ResultSet` object, or the second argument supplied to this method is not a `String` array whose elements are valid column names
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### stringToQuery

    protected Query stringToQuery(String queryString)
                           throws SQLException

Throws:
  `SQLException`

#### close

    public void close()
               throws SQLException

Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed. It is generally good practice to release resources as soon as you are finished with them to avoid tying up database resources. Calling the method `close` on a `Statement` object that is already closed has no effect. Note:When a `Statement` object is closed, its current `ResultSet` object, if one exists, is also closed.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Statement`
Throws:
  `SQLException` - if a database access error occurs

#### retrieveCallableResult

    protected ResultSet retrieveCallableResult()
                                        throws SQLException

Retrieve the output parameter result

Returns:
  a resultset.
Throws:
  `SQLException` - if any error occur

#### getMaxFieldSize

    public int getMaxFieldSize()
                        throws SQLException

Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, `NCHAR`, `NVARCHAR`, `LONGNVARCHAR` and `LONGVARCHAR` columns. If the limit is exceeded, the excess data is silently discarded.

Specified by:
  `getMaxFieldSize` in interface `Statement`
Returns:
  the current column size limit for columns storing character and binary values; zero means there is no limit
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
See Also:
  `setMaxFieldSize(int)`

#### setMaxFieldSize

    public void setMaxFieldSize(int max)
                         throws SQLException

Sets the limit for the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, `NCHAR`, `NVARCHAR`, `LONGNVARCHAR` and `LONGVARCHAR` fields. If the limit is exceeded, the excess data is silently discarded. For maximum portability, use values greater than 256.

Specified by:
  `setMaxFieldSize` in interface `Statement`
Parameters:
  `max` - the new column size limit in bytes; zero means there is no limit
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition max >= 0 is not satisfied
See Also:
  `getMaxFieldSize()`

#### getMaxRows

    public int getMaxRows()
                   throws SQLException

Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain. If this limit is exceeded, the excess rows are silently dropped.

Specified by:
  `getMaxRows` in interface `Statement`
Returns:
  the current maximum number of rows for a `ResultSet` object produced by this `Statement` object; zero means there is no limit
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
See Also:
  `setMaxRows(int)`

#### setMaxRows

    public void setMaxRows(int max)
                    throws SQLException

Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number. If the limit is exceeded, the excess rows are silently dropped.

Specified by:
  `setMaxRows` in interface `Statement`
Parameters:
  `max` - the new max rows limit; zero means there is no limit
Throws:
  `SQLException` - if the condition max >= 0 is not satisfied
See Also:
  `getMaxRows()`

#### setEscapeProcessing

    public void setEscapeProcessing(boolean enable)
                             throws SQLException

Sets escape processing on or off. If escape scanning is on (the default), the driver will do escape substitution before sending the SQL statement to the database. Note: Since prepared statements have usually been parsed prior to making this call, disabling escape processing for `PreparedStatements` objects will have no effect.

Specified by:
  `setEscapeProcessing` in interface `Statement`
Parameters:
  `enable` - `true` to enable escape processing; `false` to disable it
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`

#### getQueryTimeout

    public int getQueryTimeout()
                        throws SQLException

Retrieves the number of seconds the driver will wait for a `Statement` object to execute. If the limit is exceeded, a `SQLException` is thrown.

Specified by:
  `getQueryTimeout` in interface `Statement`
Returns:
  the current query timeout limit in seconds; zero means there is no limit
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
See Also:
  `setQueryTimeout(int)`

#### setQueryTimeout

    public void setQueryTimeout(int seconds)
                         throws SQLException

Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds. If the limit is exceeded, an `SQLException` is thrown. A JDBC driver must apply this limit to the `execute`, `executeQuery` and `executeUpdate` methods. JDBC driver implementations may also apply this limit to `ResultSet` methods (consult your driver vendor documentation for details).

Specified by:
  `setQueryTimeout` in interface `Statement`
Parameters:
  `seconds` - the new query timeout limit in seconds; zero means there is no limit
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition seconds >= 0 is not satisfied
See Also:
  `getQueryTimeout()`

#### setLocalInfileInputStream

    public void setLocalInfileInputStream(InputStream inputStream)
                                   throws SQLException

Sets the inputStream that will be used for the next execute that uses "LOAD DATA LOCAL INFILE". The name specified as local file/URL will be ignored.

Parameters:
  `inputStream` - inputStream instance, that will be used to send data to server
Throws:
  `SQLException` - if statement is closed

#### cancel

    public void cancel()
                throws SQLException

Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement. This method can be used by one thread to cancel a statement that is being executed by another thread.

Specified by:
  `cancel` in interface `Statement`
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### getWarnings

    public SQLWarning getWarnings()
                           throws SQLException

Retrieves the first warning reported by calls on this `Statement` object. Subsequent `Statement` object warnings will be chained to this `SQLWarning` object.

The warning chain is automatically cleared each time a statement is (re)executed. This method may not be called on a closed `Statement` object; doing so will cause an `SQLException` to be thrown.

Note: If you are processing a `ResultSet` object, any warnings associated with reads on that `ResultSet` object will be chained on it rather than on the `Statement` object that produced it.

Specified by:
  `getWarnings` in interface `Statement`
Returns:
  the first `SQLWarning` object or `null` if there are no warnings
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`

#### clearWarnings

    public void clearWarnings()
                       throws SQLException

Clears all the warnings reported on this `Statement` object. After a call to this method, the method `getWarnings` will return `null` until a new warning is reported for this `Statement` object.

Specified by:
  `clearWarnings` in interface `Statement`
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`

#### setCursorName

    public void setCursorName(String name)
                       throws SQLException

Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods. This name can then be used in SQL positioned update or delete statements to identify the current row in the `ResultSet` object generated by this statement. If the database does not support positioned update/delete, this method is a noop. To insure that a cursor has the proper isolation level to support updates, the cursor's `SELECT` statement should have the form `SELECT FOR UPDATE`. If `FOR UPDATE` is not present, positioned updates may fail.

Note: By definition, the execution of positioned updates and deletes must be done by a different `Statement` object than the one that generated the `ResultSet` object being used for positioning. Also, cursor names must be unique within a connection.

Specified by:
  `setCursorName` in interface `Statement`
Parameters:
  `name` - the new cursor name, which must be unique within a connection
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### getConnection

    public Connection getConnection()
                             throws SQLException

Gets the connection that created this statement.

Specified by:
  `getConnection` in interface `Statement`
Returns:
  the connection
Throws:
  `SQLException` - if connection is invalid

#### getGeneratedKeys

    public ResultSet getGeneratedKeys()
                               throws SQLException

Retrieves any auto-generated keys created as a result of executing this `Statement` object. If this `Statement` object did not generate any keys, an empty `ResultSet` object is returned.

Note:If the columns which represent the auto-generated keys were not specified, the JDBC driver implementation will determine the columns which best represent the auto-generated keys.

Specified by:
  `getGeneratedKeys` in interface `Statement`
Returns:
  a `ResultSet` object containing the auto-generated key(s) generated by the execution of this `Statement` object
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### getResultSetHoldability

    public int getResultSetHoldability()
                                throws SQLException

Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.

Specified by:
  `getResultSetHoldability` in interface `Statement`
Returns:
  either `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
Since:
  1.4

#### isClosed

    public boolean isClosed()
                     throws SQLException

Retrieves whether this `Statement` object has been closed. A `Statement` is closed if the method close has been called on it, or if it is automatically closed.

Specified by:
  `isClosed` in interface `Statement`
Returns:
  true if this `Statement` object is closed; false if it is still open
Throws:
  `SQLException` - if a database access error occurs
Since:
  1.6

#### isPoolable

    public boolean isPoolable()
                       throws SQLException

Returns a value indicating whether the `Statement` is poolable or not.

Specified by:
  `isPoolable` in interface `Statement`
Returns:
  `true` if the `Statement` is poolable; `false` otherwise
Throws:
  `SQLException` - if this method is called on a closed `Statement`
Since:
  1.6
See Also:
  `setPoolable(boolean)`

#### setPoolable

    public void setPoolable(boolean poolable)
                     throws SQLException

Requests that a `Statement` be pooled or not pooled. The value specified is a hint to the statement pool implementation indicating whether the applicaiton wants the statement to be pooled. It is up to the statement pool manager as to whether the hint is used.

The poolable value of a statement is applicable to both internal statement caches implemented by the driver and external statement caches implemented by application servers and other applications.

By default, a `Statement` is not poolable when created, and a `PreparedStatement` and `CallableStatement` are poolable when created.

Specified by:
  `setPoolable` in interface `Statement`
Parameters:
  `poolable` - requests that the statement be pooled if true and that the statement not be pooled if false
Throws:
  `SQLException` - if this method is called on a closed `Statement`
Since:
  1.6

#### getResultSet

    public ResultSet getResultSet()
                           throws SQLException

Retrieves the current result as a ResultSet object. This method should be called only once per result.

Specified by:
  `getResultSet` in interface `Statement`
Returns:
  the current result as a ResultSet object or null if the result is an update count or there are no more results
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed Statement

#### getUpdateCount

    public int getUpdateCount()
                       throws SQLException

Retrieves the current result as an update count; if the result is a ResultSet object or there are no more results, -1 is returned. This method should be called only once per result.

Specified by:
  `getUpdateCount` in interface `Statement`
Returns:
  the current result as an update count; -1 if the current result is a ResultSet object or there are no more results
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed Statement

#### skipMoreResults

    protected void skipMoreResults()
                            throws SQLException

Throws:
  `SQLException`

#### getMoreResults

    public boolean getMoreResults()
                           throws SQLException

Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`.

There are no more results when the following is true:

     // stmt is a Statement object
     ((stmt.getInternalMoreResults() == false) && (stmt.getUpdateCount() == -1))

Specified by:
  `getMoreResults` in interface `Statement`
Returns:
  `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
See Also:
  `execute(org.mariadb.jdbc.internal.query.Query, int)`

#### getMoreResults

    public boolean getMoreResults(int current)
                           throws SQLException

Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object.

There are no more results when the following is true:

     // stmt is a Statement object
     ((stmt.getInternalMoreResults(current) == false) && (stmt.getUpdateCount() == -1))

Specified by:
  `getMoreResults` in interface `Statement`
Parameters:
  `current` - one of the following `Statement` constants indicating what should happen to current `ResultSet` objects obtained using the method `getResultSet`: `Statement.CLOSE_CURRENT_RESULT`, `Statement.KEEP_CURRENT_RESULT`, or `Statement.CLOSE_ALL_RESULTS`
Returns:
  `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the argument supplied is not one of the following: `Statement.CLOSE_CURRENT_RESULT`, `Statement.KEEP_CURRENT_RESULT` or `Statement.CLOSE_ALL_RESULTS`
  `SQLFeatureNotSupportedException` - if `DatabaseMetaData.supportsMultipleOpenResults` returns `false` and either `Statement.KEEP_CURRENT_RESULT` or `Statement.CLOSE_ALL_RESULTS` are supplied as the argument.
Since:
  1.4
See Also:
  `execute(org.mariadb.jdbc.internal.query.Query, int)`

#### getFetchDirection

    public int getFetchDirection()
                          throws SQLException

Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object. If this `Statement` object has not set a fetch direction by calling the method `setFetchDirection`, the return value is implementation-specific.

Specified by:
  `getFetchDirection` in interface `Statement`
Returns:
  the default fetch direction for result sets generated from this `Statement` object
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
Since:
  1.2
See Also:
  `setFetchDirection(int)`

#### setFetchDirection

    public void setFetchDirection(int direction)
                           throws SQLException

Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object. The default value is `ResultSet.FETCH_FORWARD`.

Note that this method sets the default fetch direction for result sets generated by this `Statement` object. Each result set has its own methods for getting and setting its own fetch direction.

Specified by:
  `setFetchDirection` in interface `Statement`
Parameters:
  `direction` - the initial direction for processing rows
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the given direction is not one of `ResultSet.FETCH_FORWARD`, `ResultSet.FETCH_REVERSE`, or `ResultSet.FETCH_UNKNOWN`
Since:
  1.2
See Also:
  `getFetchDirection()`

#### getFetchSize

    public int getFetchSize()
                     throws SQLException

Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object. If this `Statement` object has not set a fetch size by calling the method `setFetchSize`, the return value is implementation-specific.

Specified by:
  `getFetchSize` in interface `Statement`
Returns:
  the default fetch size for result sets generated from this `Statement` object
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
Since:
  1.2
See Also:
  `setFetchSize(int)`

#### setFetchSize

    public void setFetchSize(int rows)
                      throws SQLException

Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for `ResultSet` objects genrated by this `Statement`. If the value specified is zero, then the hint is ignored. The default value is zero.

Specified by:
  `setFetchSize` in interface `Statement`
Parameters:
  `rows` - the number of rows to fetch
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `rows >= 0` is not satisfied.
Since:
  1.2
See Also:
  `getFetchSize()`

#### getResultSetConcurrency

    public int getResultSetConcurrency()
                                throws SQLException

Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.

Specified by:
  `getResultSetConcurrency` in interface `Statement`
Returns:
  either `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
Since:
  1.2

#### getResultSetType

    public int getResultSetType()
                         throws SQLException

Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.

Specified by:
  `getResultSetType` in interface `Statement`
Returns:
  one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
Since:
  1.2

#### addBatch

    public void addBatch(String sql)
                  throws SQLException

Adds the given SQL command to the current list of commmands for this `Statement` object. The send in this list can be executed as a batch by calling the method `executeBatch`.

Specified by:
  `addBatch` in interface `Statement`
Parameters:
  `sql` - typically this is a SQL `INSERT` or `UPDATE` statement
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch updates
Since:
  1.2
See Also:
  `executeBatch()`, `DatabaseMetaData.supportsBatchUpdates()`

#### isInsertRewriteable

    protected void isInsertRewriteable(String sql)

Parses the sql string to understand whether it is compatible with rewritten batches.

Parameters:
  `sql` - the sql string

#### getInsertIncipit

    protected int getInsertIncipit(String sql)

Parses the input string to understand if it is an INSERT statement. Returns the position of the round bracket after the VALUE(S) SQL keyword, or -1 if it cannot understand it is an INSERT statement. Multiple statements cannot be parsed.

Parameters:
  `sql` - the input SQL statement
Returns:
  the position of the round bracket after the VALUE(S) SQL keyword, or -1 if it cannot be parsed as an INSERT statement

#### clearBatch

    public void clearBatch()
                    throws SQLException

Empties this `Statement` object's current list of SQL send.

Specified by:
  `clearBatch` in interface `Statement`
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch updates
Since:
  1.2
See Also:
  `addBatch(java.lang.String)`, `DatabaseMetaData.supportsBatchUpdates()`

#### executeBatch

    public int[] executeBatch()
                       throws SQLException

Execute statements. depending on option, queries mays be rewritten : those queries will be rewritten if possible to INSERT INTO ... VALUES (...) ; INSERT INTO ... VALUES (...); if option rewriteBatchedStatements is set to true, rewritten to INSERT INTO ... VALUES (...), (...);

Specified by:
  `executeBatch` in interface `Statement`
Returns:
  an array of update counts containing one element for each command in the batch. The elements of the array are ordered according to the order in which send were added to the batch.
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch statements. Throws `BatchUpdateException` (a subclass of `SQLException`) if one of the send sent to the database fails to execute properly or attempts to return a result set.
Since:
  1.3
See Also:
  `addBatch(java.lang.String)`, `DatabaseMetaData.supportsBatchUpdates()`

#### unwrap

    public <T> T unwrap(Class<T> iface)
                 throws SQLException

Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

If the receiver implements the interface then the result is the receiver or a proxy for the receiver. If the receiver is a wrapper and the wrapped object implements the interface then the result is the wrapped object or a proxy for the wrapped object. Otherwise return the the result of calling `unwrap` recursively on the wrapped object or a proxy for that result. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.

Specified by:
  `unwrap` in interface `Wrapper`
Parameters:
  `iface` - A Class defining an interface that the result must implement.
Returns:
  an object that implements the interface. May be a proxy for the actual implementing object.
Throws:
  `SQLException` - If no object found that implements the interface
Since:
  1.6

#### isWrapperFor

    public boolean isWrapperFor(Class<?> interfaceOrWrapper)
                         throws SQLException

Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.

Specified by:
  `isWrapperFor` in interface `Wrapper`
Parameters:
  `interfaceOrWrapper` - a Class defining an interface.
Returns:
  true if this implements the interface or directly or indirectly wraps an object that does.
Throws:
  `SQLException` - if an error occurs while determining whether this is a wrapper for an object with the given interface.
Since:
  1.6

#### closeOnCompletion

    public void closeOnCompletion()
                           throws SQLException

Specified by:
  `closeOnCompletion` in interface `Statement`
Throws:
  `SQLException`

#### isCloseOnCompletion

    public boolean isCloseOnCompletion()
                                throws SQLException

Specified by:
  `isCloseOnCompletion` in interface `Statement`
Throws:
  `SQLException`

#### checkClose

    protected void checkClose()
                       throws SQLException

Check if statement is closed, and throw exception if so.

Throws:
  `SQLException` - if statement close